#ifndef BACK_CONSTS_H
#define BACK_CONSTS_H

typedef struct imgs {
    int len; 
    SDL_Texture** arr;
} imgs ;

typedef struct array {
    int* arr ;
    int len ;
} array ;

typedef struct pt_3d {
    double x;
    double y;
    double z;
} pt_3d ;

typedef struct pt_3d_int {
    int x;
    int y;
    double z;
} pt_3d_int ;

typedef enum cardinal {NORTH, EAST, SOUTH, WEST} cardinal ;

extern Grid map ;

extern int zoom ;

extern int render_distance ;

extern double speed ;
extern int precision ;

extern double εx ;
extern double εy ;
// are in [0.0, 1.0[

extern int player_x ;
extern int player_y ;
// are in [|0, 8[|

extern int player_cx ;
extern int player_cy ;
// any integer

extern int draw_par ;

extern int __width__ ;
extern int __height__ ;

extern template* configs ;
extern int n_configs ;      // 2nd length

extern imgs digits ;
extern imgs letters ;

extern template full ;

extern double** screen_zbuffer ;
extern uint8_t** screen_red ;
extern uint8_t** screen_green ;
extern uint8_t** screen_blue ;

extern double three_render_distance ;
extern int three_angle ;

extern double* cosinuses ;
extern double* sinuses ;

extern double ar ;

#endif